/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14-3-19
 * Time: 下午4:11
 * To change this template use File | Settings | File Templates.
 */

var app = app = app || {};

app.PUBLIC_SDK = {
	UNIPLAY		: 1,
	EGAME		: 2,
	MM			: 3,
	ANDGAME		: 4
}
app.CURRENT_PUBLIC_SDK = app.PUBLIC_SDK.MM

app.Config = {
	AppID : null,
	AppName : "Dungeon",
	AppAlias : "Dungeon_",
	AppURL : null,

	// If there is removeAd IAP, it MUST be at the first place
	IAPs : [],
	LeaderboardIDs : [],

	// use for utils.rate()
	RateURL : null,
	// use for moregame button
	PromoURL : "http://www.veewo.com",
	// use for combine promo config download URL
	PromoChannel : "promo",
	PromoBannerEnable : true,
	PromoFullScreenEnable : true,


	AdBannerPluginName : "AdsGoogle",
	AdBannerPluginConfig : null,

	//plugin
	AnalyticsPluginName : "AnalyticsTalkingGame",
	//AnalysticsPluginConfig : "FA9B717009BF4DC44C44C10321DB537C",
	AnalysticsPluginConfig : "FB907119F30DDCE8400A2D1B1B534E0D",

	VideoAdPluginName : null,
	VideoAdConfig : null,

	AdInterstialPluginName : "AdsMongo",
	AdInterstialPluginCoinfig : null,

	IsBannerEnabled : true,
	IsInterestialEnabled : true,

	//评价
	arrRateUs : [3, 15, 30],

	//支付
	// IAPPluginName : "IAPUniplay",
	// IAPPluginName : "IAPEGame",
	// IAPPluginName : "IAPMM",
	// IAPPluginName : "IAPAndGame",
	IAPConfig : {}
};

app.Config.iOS = {

	AdBannerPluginName : "AdsGoogle",
	AdBannerPluginConfig : {
		AppGoogleBannerId : "ca-app-pub-4272718464439486/5854109254",
		AppGoogleInterstialId : "ca-app-pub-4272718464439486/1284308851"
	},

	//支付
	IAPs : [
		{ProductID: "com.clownbox.dungeon.99gem", NonConsumable:"false"},
		{ProductID: "com.clownbox.dungeon.199gem", NonConsumable:"false"}
	]
}

app.Config.android =
{
	AppDefaultClass : "com/clownbox/VeeCommon/VeeCommon",

	AdBannerPluginName : "AdsGoogle",
	AdBannerPluginConfig : {
		AppGoogleBannerId : "ca-app-pub-6484958400152525/9687543494",
		AppGoogleInterstialId : "ca-app-pub-6484958400152525/2164276694"
	},

	GameCenterPluginName : "SocialGameCenter",
	GameCenterPluginConfig : {},

	LeaderboardIDs : ["CgkI6PSGna8bEAIQBQ"],

	//支付
	IAPConfig : {IAPID : "9022960754020151023154128275200"},

	//联通
	// IAPs : [
		// {ProductID: "003", NonConsumable:"false"},
		// {ProductID: "001", NonConsumable:"false"},
		// {ProductID: "002", NonConsumable:"false"},
		// {ProductID: "004", NonConsumable:"false"}
	// ],
	//电信
	// IAPs : [
		// {ProductID: "TOOL3", NonConsumable:"false"},
		// {ProductID: "TOOL1", NonConsumable:"false"},
		// {ProductID: "TOOL2", NonConsumable:"false"},
		// {ProductID: "TOOL4", NonConsumable:"false"}
	// ],
	//移动
	// IAPs : [
		// {ProductID: "30000922838103", NonConsumable:"false"},
		// {ProductID: "30000922838101", NonConsumable:"false"},
		// {ProductID: "30000922838102", NonConsumable:"false"},
		// {ProductID: "30000922838104", NonConsumable:"false"}
	// ],
	//咪咕
	// IAPs : [
		// {ProductID: "003", NonConsumable:"false"},
		// {ProductID: "001", NonConsumable:"false"},
		// {ProductID: "002", NonConsumable:"false"},
		// {ProductID: "004", NonConsumable:"false"}
	// ],

	AppID : "com.clownbox.Dungeon"
}

if (app.CURRENT_PUBLIC_SDK == app.PUBLIC_SDK.UNIPLAY)
{
	app.Config.IAPPluginName = "IAPUniplay";
	app.Config.android.IAPs = [
		{ProductID: "003", NonConsumable:"false"},
		{ProductID: "001", NonConsumable:"false"},
		{ProductID: "002", NonConsumable:"false"},
		{ProductID: "004", NonConsumable:"false"}
	];
}
else if (app.CURRENT_PUBLIC_SDK == app.PUBLIC_SDK.EGAME)
{
	app.Config.IAPPluginName = "IAPEGame";
	app.Config.android.IAPs = [
		{ProductID: "TOOL3", NonConsumable:"false"},
		{ProductID: "TOOL1", NonConsumable:"false"},
		{ProductID: "TOOL2", NonConsumable:"false"},
		{ProductID: "TOOL4", NonConsumable:"false"}
	]
}
else if (app.CURRENT_PUBLIC_SDK == app.PUBLIC_SDK.MM)
{
	app.Config.IAPPluginName = "IAPMM";
	app.Config.android.IAPs = [
		{ProductID: "30000922838103", NonConsumable:"false"},
		{ProductID: "30000922838101", NonConsumable:"false"},
		{ProductID: "30000922838102", NonConsumable:"false"},
		{ProductID: "30000922838104", NonConsumable:"false"}
	];
}
else if (app.CURRENT_PUBLIC_SDK == app.PUBLIC_SDK.ANDGAME)
{
	app.Config.IAPPluginName = "IAPAndGame";
	app.Config.android.IAPs = [
		{ProductID: "003", NonConsumable:"false"},
		{ProductID: "001", NonConsumable:"false"},
		{ProductID: "002", NonConsumable:"false"},
		{ProductID: "004", NonConsumable:"false"}
	];
}

app.init = function(isFirstPlay){

	var config = vee.Utils.getObjByPlatform(app.Config.iOS, app.Config.android, {});
	for (var i in config){
		app.Config[i] = config[i];
	}

	if (isFirstPlay) {
		vee.saveData();
	}

	// add your app launch code here
}

app.leave = function (argument) {
	//will resign focus , save data here

	GameManager.saveGameData();
}

app.resume = function (argument) {
	//activated from background
}