/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/14
 * Time: 上午11:38
 * To change this template use File | Settings | File Templates.
 */

vee.GameModule.MainLayer.extend({

	/** @expose */
	m_lyMainLayer : null,

	//初始化
	onLoaded : function()
	{
		this.m_lyMainLayer.controller.onLoaded();
	},
	//关闭界面
	onClosed : function()
	{
		this.m_lyMainLayer.controller.onClosed();
	},
	//
	onKeyMenu : function() {
		return true;
	}
});

//第一次进入游戏
vee.m_bEnterFirst = true;
var lyMainLayer = vee.Class.extend({

	/** @expose */
	m_noSelect : null,

	/** @expose */
	m_lyMainBgLayer : null,
	/** @expose */
	m_lyMainUiLayer : null,

	//装备页
	m_lyEquipmentLayer : null,
	//仓库页
	m_lyInventoryLayer : null,

	//是否进入游戏
	m_bEnterGame : false,
	//按钮位置
	m_pointBtn : null,
	//按钮位置
	m_pointBtn2 : null,
	//第一个塔的位置
	m_pointTower : null,

	//id
	m_strOrderId : "1",

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	//初始化
	onLoaded : function()
	{
		//ui
		this.m_lyMainUiLayer.controller.setMainLayer(this);
		//bg
		this.m_lyMainBgLayer.controller.setMainLayer(this);
		this.m_lyMainBgLayer.controller.onLoaded();
		vee.Audio.playMusic(res.bgm_layer_main_mp3);
	},
	//关闭界面
	onClosed : function()
	{
		this.m_lyMainUiLayer.controller.onClosed();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果1
	//进入效果
	onEnter : function()
	{
		//进入效果
		if(GameManager.m_bInTower){
			if (vee.m_bEnterFirst){
				vee.m_bEnterFirst = false;
			}
			this.enterGame(GameManager.m_bInTower);
		}else{
			this.m_lyMainUiLayer.controller.showUi();
		}
	},
	//进入游戏
	enterGame : function(bDirect)
	{
		if(bDirect)
		{
			//ui移出
			this.m_lyMainUiLayer.controller.playAnimate("GameEnd", null, false);
			//进入效果2
			this.m_lyMainBgLayer.controller.playAnimate("EnterTower2", this.enterTowerCallback.bind(this), false);
		}
		else
		{
			//进入效果1
			this.m_lyMainBgLayer.controller.playAnimate("EnterTower", this.enterTowerCallback.bind(this), false);
		}
	},
	//进入回调
	enterTowerCallback : function()
	{
		//初始化塔内数据
		GameManager.initTower();
		//进入游戏
		vee.GameModule.SceneMgr.openGame();
	},
	//显示宝箱
	showChests : function()
	{
		var bShow = false;
		var nFloor = GameManager.getCurrentFloor();
		if (nFloor >= 6 && !vee.data["BRAVE_CHESTS_6F"])
		{
			vee.data["BRAVE_CHESTS_6F"] = true;
			vee.saveData();
			bShow = true;
		}
		if (vee.m_bEnterFirst)
		{
			if (vee.data["BRAVE_CHESTS_1F"])
			{
				bShow = true;
			}
			else
			{
				vee.data["BRAVE_CHESTS_1F"] = true;
				vee.saveData();
			}
			vee.m_bEnterFirst = false;
		}
		if (bShow)
		{
			this.openChests();
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果2
	//初次进入奖励
	showFirstAward : function()
	{
		//按钮位置
		this.m_pointBtn = this.m_lyMainUiLayer.controller.getPlayerBtnPosition();
		this.m_pointBtn2 = this.m_lyMainUiLayer.controller.getPlayerBtnPosition2();
		this.m_pointTower = this.m_lyMainBgLayer.controller.getFirstTowerPosition();

		//教程--进入游戏
		if((vee.data["GameCourse"] & CourseType.CourseFirstInGame) != CourseType.CourseFirstInGame)
		{
			var layer = vee.PopMgr.popCCB(res.lyCourse_ccbi, { alpha : 0 });
			layer.controller.setLyCourse(CourseType.CourseFirstInGame, this);
			vee.data["GameCourse"] |= CourseType.CourseFirstInGame;
		}

		//教程--滑动
		if((vee.data["GameCourse"] & CourseType.CourseFirstOutTower) != CourseType.CourseFirstOutTower && GameManager.m_bPassGame)
		{
			var layer = vee.PopMgr.popCCB(res.lyCourse_ccbi, { alpha : 0 });
			layer.controller.setLyCourse(CourseType.CourseFirstOutTower, this);
			vee.data["GameCourse"] |= CourseType.CourseFirstOutTower;
		}

		//教程--滑动
		if((vee.data["GameCourse"] & CourseType.CourseFirstWinTower) != CourseType.CourseFirstWinTower && GameManager.m_bPassGame2)
		{
			var layer = vee.PopMgr.popCCB(res.lyCourse_ccbi, { alpha : 0 });
			layer.controller.setLyCourse(CourseType.CourseFirstWinTower, this);
			vee.data["GameCourse"] |= CourseType.CourseFirstWinTower;
		}

		//弹出宝箱（移动的弹窗）
		if (app.CURRENT_PUBLIC_SDK == app.PUBLIC_SDK.MM)
		{
			this.showChests();
		}
		// this.showChests();

		//判断初次进入
		if(!vee.isFirstPlay){
			return;
		}
		//----------------------------------------

		//弹出提示
		var node = noPopupNode.createTouchHintWithIcon(GameMessage.Mes_FirstAward, "",
				this.showFirstAwardCallBack.bind(this), "item_1081.png", false);
		vee.PopMgr.popLayer(node, { alpha : 100 }, null, null, null);
	},
	//回调
	showFirstAwardCallBack : function()
	{
		//保存数据
		vee.VIPValues.add2Value(VipKey.Jewel, 15);
		vee.VIPValues.save();
		//刷新钻石
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, 0);
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	//显示
	//更新金钱显示
	upDataCurrentMoney : function()
	{
		var oVipData = GameManager.getVIPData();
		this.m_lyMainUiLayer.controller.setDisplayMoney(oVipData.m_nMoney);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调1
	//修改楼层
	setFloor : function(nFloor)
	{
		//修改层数
		GameManager.getTowerData().m_nBigFloor = nFloor;
		//上升下落效果
		this.m_lyMainBgLayer.controller.upDownTower(nFloor);
		//判断边界
		return GameManager.isMaxFloor(true);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调2
	//打开SelectNode
	showSelect : function(nFloor)
	{
		//数据
		var oVipData = GameManager.getVIPData();
		
		//----------------------------------------
		
		//直接进入游戏
		if(oVipData.m_nOpenFloor == 1)
		{	
			this.enterGame(true);
			return false;
		}
		
		//----------------------------------------

		//修改楼层
		var oTowerData = GameManager.getTowerData();
		oTowerData.m_nBigFloor = nFloor;
		//初始化选择界面
		this.m_noSelect = vee.PopMgr.popCCB(res.eleSelectNode_ccbi, { alpha : 0 }, null, null, null);
		this.m_noSelect.controller.initSelectNode(oTowerData.m_nBigFloor, oVipData.m_nOpenFloor > 8 ? 8 : oVipData.m_nOpenFloor);
		this.m_noSelect.controller.setDelegate(this);
		//打开效果
		this.m_noSelect.controller.openSelectNode();
		this.m_lyMainUiLayer.controller.playAnimate("GameEnd", null, false);

		return true;
	},
	//关闭SelectNode
	hideSelect : function(bEnterGame, nPotion)
	{
		//标记进入游戏
		this.m_bEnterGame = bEnterGame;

		//判断进入塔中
		if(!bEnterGame)
		{
			//关闭效果
			this.m_lyMainBgLayer.controller.hideTowerSelect();
			this.m_lyMainUiLayer.controller.playAnimate("GameReset", null, false);
		}
		else
		{
			//购买血瓶
			if(GameManager.buyPotion(nPotion)){
				MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY, 0);
			}
		}

		//关闭效果
		this.m_noSelect.controller.closeSelectNode();
	},
	//隐藏选关回调
	hideSelectCallBack : function()
	{
		//进入游戏
		if(this.m_bEnterGame)
		{
			//进入塔标记
			this.m_bEnterGame = false;
			//进塔效果
			this.enterGame(false);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//ui
	//打开勇者宝箱
	openChests : function()
	{
		// this.chestsSuccessCallBack();
		// var lyPopupLayer = noPopupNode.createBtnHint(GameMessage.Mes_WantToTopUp3, "勇者宝箱",
		// 	false, true, this.chestsTopUpCallBack.bind(this), null, null, false);
		// vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},
	//充值勇者宝箱
	chestsTopUpCallBack : function()
	{
		//统计
		this.m_strOrderId = ''+vee.Utils.getTimeNow();
		vee.Analytics.logChargeRequest(this.m_strOrderId, app.Config.IAPs[3], 20, null, 120, null);
		vee.IAPMgr.buyProduct(3, this.chestsSuccessCallBack.bind(this), this.chestsFailCallBack.bind(this), function(){});
	},
	//充值成功回调
	chestsSuccessCallBack : function()
	{
		var jewelCount = 120;
		var coinCount = 300000;
		//修改钻石
		vee.VIPValues.add2Value(VipKey.Jewel, jewelCount);
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, vee.VIPValues.getValue(VipKey.Jewel));
		//修改金币
		GameManager.getVIPData().m_nMoney += coinCount;
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY, 0);
		//修改指南针
		vee.VIPValues.setValue(VipKey.Compass, 1);
		GameManager.calCompass();
		GameManager.resetCompass();

		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"Purchase success, you`ve got " + jewelCount + " diamonds!",
		   		"購買成功！获得了" + jewelCount + "钻石+" + coinCount + "金币+指南针一次！"
			]),
			vee.Utils.getObjByLanguage([
				"CONGRATULATION",
				"恭喜"
			]));

		//统计
		// vee.Analytics.logChargeSuccess(this.m_strOrderId);
	},
	//充值失败回调
	chestsFailCallBack : function(productID)
	{
		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"Recharge failure, please try again!",
				"购买失败，请重试。"
			]),
			vee.Utils.getObjByLanguage([
				"RECHARGE FAILURE",
				"购买失败"
			]));
	},
	//打开装备
	openPlayer  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		this.m_lyEquipmentLayer = vee.PopMgr.popCCB(res.lyEquipment_ccbi, { alpha : 0 });
		this.m_lyEquipmentLayer.controller.initEquipmentWithType(EquipBarFunction.Upgrade | EquipBarFunction.Exchange);
		this.m_lyEquipmentLayer.controller.setMainLayer(this);
	},
	//打开仓库
	openBank  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		this.m_lyInventoryLayer = vee.PopMgr.popCCB(res.lyInventoryMain_ccbi, { alpha : 0 });
		this.m_lyInventoryLayer.controller.initInventoryWithType(EquipBarFunction.Upgrade | EquipBarFunction.Sell);
		this.m_lyInventoryLayer.controller.setMainLayer(this);
	},
	//打开仓库
	openShop  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		this.m_lyInventoryLayer = vee.PopMgr.popCCB(res.lyShopLayer_ccbi, { alpha : 0 });
	},
	//打开声明
	openAboutGame  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		var about = vee.PopMgr.popCCB(res.lyAboutGame_ccbi, { alpha : 0 });
		about.controller.initAbout();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//打开解锁楼层
	openUnLockFloorHint : function()
	{
		//确定价格
		var nPrice = GameFormula.floorPrice(GameManager.getVIPData().m_nUnLockFloor);
		var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Coin);
		//设置弹出页
		if (bConfirm)
		{
			var strContent = GameMessage.unLockFloorMessage();
			var lyPopupLayer = noPopupNode.createBtnHint(strContent, nPrice, true, bConfirm,
				this.unLockFloorCallback.bind(this), null, res.img_coin_png, bConfirm);
			vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		}
		else
		{
			var strContent = GameMessage.enoughCoin();
			var lyPopupLayer = noPopupNode.createBtnHint(strContent, nPrice, true, true,
				this.openShop.bind(this), null, res.img_coin_png, bConfirm);
			vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		}
	},
	//解锁回调
	unLockFloorCallback : function()
	{
		//解锁
		GameManager.unLockFloor();
		//解锁效果
		this.m_lyMainBgLayer.controller.showUnLockFloor(GameManager.getVIPData().m_nOpenFloor);
		//刷新金钱
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY, 0);
	}
});
cc.BuilderReader.registerController("lyMainLayer", lyMainLayer);


VeeSoundButton = VeeSoundButton.extend({
	/** @expose */
	onChange : function(){
		var a = vee.Audio;
		a.setSoundEnabled(!a.soundEnabled);
		a.setMusicEnabled(!a.musicEnabled);
		this.btnChange.setSelected(a.soundEnabled);
		a.onEvent("button");
	}
});