/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/3/7
 * Time: 下午12:20
 * To change this template use File | Settings | File Templates.
 */

var lyShopLayer = vee.Class.extend({

	/** @expose */
	m_noTableNode : null,

	//------------------------------------------------------

	//列表相关
	//tableview
	m_noTable : null,
	//当前item
	m_oCurItem : null,

	//------------------------------------------------------

	//关闭表示
	m_bTouch : false,
	//id
	m_strOrderId : "1",
	m_strOrderNum : 0,

	//------------------------------------------------------------------------------------------------------------
	//初始化

	//初始化
	onLoaded : function()
	{
		//初始化shopItem
		var arrCCb = [];
		for(var i = 0; i < ShopData.length; i++)
		{
			if(i < 1){
				arrCCb.push(res.noShopItem2_ccbi);
			}else{
				arrCCb.push(res.noShopItem_ccbi);
			}
		}
		var noTable = VeeTableViewController.createTableView(this.m_noTableNode.getContentSize(), arrCCb, 0, null);
		this.m_noTableNode.addChild(noTable);

		//-------------------------------------------

		//设置观察者
		MyNotificationCenter.addObserver(this, GameEvent.BUYSHOPITEM, this.buyShopItem);

		//-------------------------------------------

		//打开效果
		this.playAnimate("open", this.openCallBack.bind(this), false);
	},

	//------------------------------------------------------------------------------------------------------------
	//回调
	//购买回调
	buyShopItem : function(oItem)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//当前item
		this.m_oCurItem = oItem;

		//--------------------------------------------------------------

		//当前数据
		var oShopData = oItem.m_oData;
		//现金，钻石消费
		switch (oShopData.PayType)
		{
			case ShopPayType.Cash:
			{
				this.gameTopUp(oShopData.Id);
			}
				break;
			case ShopPayType.Jewel:
			{
				this.buyJewelItem(oShopData);
			}
				break;
			case ShopPayType.Video:
			{
				this.showVideo();
			}
				break;
		}
	},

	//------------------------------------------------------------------------------------------------------------
	//购买逻辑
	//充值
	gameTopUp : function(Id)
	{
		// var lyPopupLayer = noPopupNode.createBtnHint(GameMessage.Mes_WantToTopUp, "",
													 // false, true, this.gameTopUpCallBack.bind(this), null, null, false);
		// vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		switch (Id)
			{
			case 1:
			{
				this.gameTopUpCallBack.bind(this)()
			}
				break;
			case 2:
			{
				this.gameTopUpCallBack2.bind(this)()
			}
				break;
		}
	},
	//充值回调
	gameTopUpCallBack : function()
	{
		this.topUpSuccessCallBack();
//		//修改钻石
//		vee.VIPValues.add2Value(VipKey.Jewel, 60);
//		//修改钻石
//		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, vee.VIPValues.getValue(VipKey.Jewel));
//
//		return;

		this.m_strOrderId = ''+vee.Utils.getTimeNow();
		this.m_strOrderNum = 1;
		//统计
		cc.log("this.m_strOrderId = "+this.m_strOrderId);
		// vee.Analytics.logChargeRequest(this.m_strOrderId, app.Config.IAPs[1], 6, null, 60, null);
		// //请求
		// vee.IAPMgr.buyProduct(this.m_strOrderNum, this.topUpSuccessCallBack.bind(this), this.topUpFailCallBack.bind(this), function(){});
	},
	//充值回调
	gameTopUpCallBack2 : function()
	{
		this.topUpSuccessCallBack();
		
		this.m_strOrderId = ''+vee.Utils.getTimeNow();
		this.m_strOrderNum = 2;
		//统计
		cc.log("this.m_strOrderId = "+this.m_strOrderId);
		// vee.Analytics.logChargeRequest(this.m_strOrderId, app.Config.IAPs[2], 30, null, 400, null);
		// //请求
		// vee.IAPMgr.buyProduct(this.m_strOrderNum, this.topUpSuccessCallBack.bind(this), this.topUpFailCallBack.bind(this), function(){});
	},
	//充值成功回调
	topUpSuccessCallBack : function(productID)
	{
		var jewel_count = 0;
		if (this.m_strOrderNum == 1)
		{
			jewel_count = 60;
		}
		else
		{
			jewel_count = 400;
		}

		//修改钻石
		vee.VIPValues.add2Value(VipKey.Jewel, jewel_count);
		//修改钻石
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, vee.VIPValues.getValue(VipKey.Jewel));

		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"Purchase success, you`ve got " + jewel_count + " diamonds!",
		   		"購買成功！获得了" + jewel_count + "钻石！"
			]),
			vee.Utils.getObjByLanguage([
				"CONGRATULATION",
				"恭喜"
			]));

		//统计
		// vee.Analytics.logChargeSuccess(this.m_strOrderId);
		var oMes = {
			"TowerNumber" : '' + GameManager.getVIPData().m_nOpenFloor,
			"Jewel"       : '' + (Math.floor(vee.VIPValues.getValue(VipKey.Jewel) / 10) * 10)
		};
		vee.Analytics.logEvent(StatEventId.PurchaseSuccess, oMes);
	},
	//充值失败回调
	topUpFailCallBack : function(productID)
	{
		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"Recharge failure, please try again!",
				"购买失败，请重试。"
			]),
			vee.Utils.getObjByLanguage([
				"RECHARGE FAILURE",
				"购买失败"
			]));
	},
	//购买回调2
	buyCallBack2 : function()
	{
		vee.PopMgr.alert(GameMessage.Mes_WantToTopUp2, "", this.comfirmBuyJewel.bind(this));
	},
	//充值回调
	comfirmBuyJewel : function()
	{
		vee.Analytics.showVideo();
		if (vee.Analytics.hasReady() == "true") {
			this.topUpSuccessCallBack2();
		}
		//统计
		// this.m_strOrderId = ''+vee.Utils.getTimeNow();
		// cc.log("this.m_strOrderId = "+this.m_strOrderId);
		// vee.Analytics.logChargeRequest(this.m_strOrderId, app.Config.IAPs[0], 10, null, 120, null);
		// vee.IAPMgr.buyProduct(0, this.topUpSuccessCallBack2.bind(this), this.topUpFailCallBack.bind(this), function(){});
	},
	//充值成功回调
	topUpSuccessCallBack2 : function(productID)
	{
		var count = 2;
		var rand = Math.floor(Math.random() * 100);
		cc.log("MxAdManager--购买钻石-" + count + ", " + rand);
		if(rand < 50){
			count = 2;
		}else if(rand < 80){
			count = 3;
		}else if(rand < 90){
			count = 4;
		}else if(rand < 95){
			count = 5;
		}else if(rand < 96){
			count = 6;
		}else if(rand < 97){
			count = 7;
		}else if(rand < 98){
			count = 8;
		}else if(rand < 99){
			count = 9;
		}else
		{
			count = 10;
		}

		//修改钻石
		vee.VIPValues.add2Value(VipKey.Jewel, count);
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, vee.VIPValues.getValue(VipKey.Jewel));

		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"success, you`ve got " + count + " diamonds!",
				"恭喜！获得了" + count + "钻石！"
			]),
			vee.Utils.getObjByLanguage([
				"CONGRATULATION",
				"恭喜"
			]));

		//统计
		// vee.Analytics.logChargeSuccess(this.m_strOrderId);
	},

	//钻石购买
	buyJewelItem : function(oShopData)
	{
		if(EquipManager.checkTravelIsFull() && (oShopData.FunctionType == ShopFunctionType.EquipSp))
		{
			var strContent = GameMessage.Mes_PackFull2;
			var lyPopupLayer = noPopupNode.createTouchHint(strContent, null);
			vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		}
		else
		{
			//判断是否够钱
			var nPrice = this.m_oCurItem.m_nPrice;
			var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Jewel);
			//设置弹出页
			var lyPopupLayer = noPopupNode.createBtnHintWithIcon(GameMessage.Mes_WantToBuy, nPrice, true, true,
																 bConfirm ? this.buyCallBack.bind(this) : this.buyCallBack2.bind(this),
															     null, oShopData.Icon2, oShopData, res.img_gem_png, bConfirm);
			vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		}
	},
	showVideo:function() {
		this.comfirmBuyJewel();
	},
	//购买回调
	buyCallBack : function(oShopData)
	{
		//购买逻辑
		GameManager.buySpecialEquip(oShopData, this.m_oCurItem.m_nPrice, true);

		//修改钻石
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, vee.VIPValues.getValue(VipKey.Jewel));
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY, 0);

		//回调
		if(oShopData.FunctionType == ShopFunctionType.Dilatation){
			this.m_oCurItem.setPrice();
		}
		this.m_oCurItem.setBtn();
		this.m_oCurItem = null;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	//关闭
	/** @expose */
	closeLayer : function(pSender)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//------------------------------------------------------------

		//移除观察者
		MyNotificationCenter.removeObserver(this, GameEvent.BUYSHOPITEM);

		//------------------------------------------------------------

		//关闭标记
		this.m_bTouch = false;
		//关闭效果
		this.playAnimate("close", this.closeCallBack.bind(this), false);
	},
	//打开关闭回调
	openCallBack : function()
	{
		this.m_bTouch = true;
	},
	closeCallBack : function()
	{
		vee.PopMgr.closeLayerByCtl(this);
	}
});
cc.BuilderReader.registerController("lyShopLayer", lyShopLayer);
